//+------------------------------------------------------------------+
//|                                                    SMA Greed.mqh |
//|                                            Copyright 2015, Urain |
//|                            https://login.mql5.com/ru/users/Urain |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, Urain"
#property link      "https://login.mql5.com/ru/users/Urain"
//+------------------------------------------------------------------+
//| #include <SMA Greed.mqh>                                         |
//+------------------------------------------------------------------+
#include <IncMAOnArray.mqh>
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class CSMA_Greed
  {
   CMAOnArray        chsma;
   struct SDoubleArray { double       m[];};
   int               m_max_period;
   int               rt,prv;
   double            temp;
public:
   SDoubleArray      d[];
                     CSMA_Greed(void){};
                    ~CSMA_Greed(void){};
   void              Init(int MaxMAperiod=32);
   void              Solve(const int aRatesTotal,const int aPrevCalc,const double  &aData[]);
  };
//+------------------------------------------------------------------+
void  CSMA_Greed::Init(int MaxMAperiod=32)
  {
   m_max_period=MaxMAperiod;
   chsma.Init(m_max_period,MODE_SMA);
   ArrayResize(d,m_max_period);
  };
//+------------------------------------------------------------------+
void  CSMA_Greed::Solve(const int aRatesTotal,const int aPrevCalc,const double  &aData[])
  {
   rt=aRatesTotal; prv=aPrevCalc;
   for(int i=0;i<m_max_period;i++)ArrayResize(d[i].m,rt);
   chsma.Solve(rt,prv,aData,d[m_max_period-1].m);

   for(int i=prv>m_max_period?prv:m_max_period;i<rt;i++)
     {
      temp=d[m_max_period-1].m[i]*m_max_period;
      for(int j=m_max_period-2;j>=0;j--)
        {
         temp-=aData[i-(j+1)];
         d[j].m[i]=temp/(j+1);
        }
     }
  };
//+------------------------------------------------------------------+
